=== isagenerator/Makefile ===
.PHONY: all

all:
	python3 generate_tables.py instructions
