=== debian/changelog ===
bddisasm (1.37.0-0parrot1) parrot-updates; urgency=medium

  * Update changelog for 1.34.10-1parrot1 release
  * New upstream version 1.37.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Mon, 05 Jun 2023 20:40:54 +0700

bddisasm (1.34.10-1parrot1) parrot-updates; urgency=medium

  [ Nong Hoang Tu ]
  * Initial release

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 28 Feb 2023 20:53:26 +0700
