=== debian/control ===
Source: bddisasm
Section: utils
Priority: optional
Maintainer: Parrot Team <team@parrotsec.org>
Uploaders: Nong Hoang Tu <dmknght@parrotsec.org>
Build-Depends: debhelper-compat (= 13), cmake, rapidjson-dev
Standards-Version: 4.5.1
Homepage: https://github.com/bitdefender/bddisasm/
#Vcs-Browser: https://salsa.debian.org/debian/bddisasm
#Vcs-Git: https://salsa.debian.org/debian/bddisasm.git
Rules-Requires-Root: no

Package: bddisasm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The BitDefender disassembler
 The Bitdefender disassembler (bddisasm) is a lightweight,
 x86/x64 only instruction decoder. It is easy to integrate,
 easy to work with, it has no external dependencies, it is
 thread-safe, it allocates no memory at all, it works in
 virtually any environment (we use it inside user, kernel,
 hypervisor, on both Windows and Linux environments),
 and it provides lots of info regarding the decoded instructions,
 such as: operands (both explicit and implicit), access mode
 for each operand, CPUID feature flag, flags access, etc.


Package: libbddisasm-dev
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Architecture: any
Description: The BitDefender disassembler devel files
 This package provides header files and static libs
