=== debian/watch ===
version=4
https://github.com/bitdefender/bddisasm/tags/ .*/v(\d.+)\.tar\.gz
